/*
 *     This file is part of the Squashtest platform.
 *     Copyright (C) Henix, henix.fr
 *
 *     See the NOTICE file distributed with this work for additional
 *     information regarding copyright ownership.
 *
 *     This is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU Lesser General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 *
 *     this software is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU Lesser General Public License for more details.
 *
 *     You should have received a copy of the GNU Lesser General Public License
 *     along with this software.  If not, see <http://www.gnu.org/licenses/>.
 */
package org.squashtest.tm.service.internal.dto.projectimporterxray.jooq.tables;

import org.jooq.Field;
import org.jooq.Name;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.Internal;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;
import org.squashtest.tm.service.internal.dto.projectimporterxray.jooq.dto.ItemXrayDto;

/** This class is generated by jOOQ and modified. */
@SuppressWarnings({"all", "unchecked", "rawtypes"})
public class ItemTable extends TableImpl<ItemTableRecord> {
    private static final long serialVersionUID = 1L;

    @Override
    public Class<ItemTableRecord> getRecordType() {
        return ItemTableRecord.class;
    }

    public final TableField<ItemTableRecord, Long> ID =
            createField(DSL.name("id"), SQLDataType.BIGINT.nullable(false).identity(true), this, "");

    public final TableField<ItemTableRecord, String> PROJECT =
            createField(
                    DSL.name("project"),
                    SQLDataType.CLOB.defaultValue(DSL.field("NULL", SQLDataType.CLOB)),
                    this,
                    "");

    public final TableField<ItemTableRecord, String> TITLE =
            createField(
                    DSL.name("title"),
                    SQLDataType.CLOB.defaultValue(DSL.field("NULL", SQLDataType.CLOB)),
                    this,
                    "");

    public final TableField<ItemTableRecord, String> LINK =
            createField(
                    DSL.name("link"),
                    SQLDataType.CLOB.defaultValue(DSL.field("NULL", SQLDataType.CLOB)),
                    this,
                    "");

    public final TableField<ItemTableRecord, String> DESCRIPTION =
            createField(
                    DSL.name("description"),
                    SQLDataType.CLOB.defaultValue(DSL.field("NULL", SQLDataType.CLOB)),
                    this,
                    "");

    public final TableField<ItemTableRecord, String> KEY =
            createField(
                    DSL.name("key"),
                    SQLDataType.CLOB.defaultValue(DSL.field("NULL", SQLDataType.CLOB)),
                    this,
                    "");

    public final TableField<ItemTableRecord, String> SUMMARY =
            createField(
                    DSL.name("summary"),
                    SQLDataType.CLOB.defaultValue(DSL.field("NULL", SQLDataType.CLOB)),
                    this,
                    "");

    public final TableField<ItemTableRecord, String> TYPE =
            createField(
                    DSL.name("type"),
                    SQLDataType.CLOB.defaultValue(DSL.field("NULL", SQLDataType.CLOB)),
                    this,
                    "");

    public final TableField<ItemTableRecord, String> PRIORITY =
            createField(
                    DSL.name("priority"),
                    SQLDataType.CLOB.defaultValue(DSL.field("NULL", SQLDataType.CLOB)),
                    this,
                    "");

    public final TableField<ItemTableRecord, String> STATUS =
            createField(
                    DSL.name("status"),
                    SQLDataType.CLOB.defaultValue(DSL.field("NULL", SQLDataType.CLOB)),
                    this,
                    "");

    public final TableField<ItemTableRecord, String> CREATED =
            createField(
                    DSL.name("created"),
                    SQLDataType.CLOB.defaultValue(DSL.field("NULL", SQLDataType.CLOB)),
                    this,
                    "");

    public final TableField<ItemTableRecord, String> REPORTER =
            createField(
                    DSL.name("reporter"),
                    SQLDataType.CLOB.defaultValue(DSL.field("NULL", SQLDataType.CLOB)),
                    this,
                    "");

    public final TableField<ItemTableRecord, String> LABEL =
            createField(
                    DSL.name("label"),
                    SQLDataType.CLOB.defaultValue(DSL.field("NULL", SQLDataType.CLOB)),
                    this,
                    "");

    public final TableField<ItemTableRecord, String> PIVOT_ID =
            createField(
                    DSL.name("pivot_id"),
                    SQLDataType.CLOB.defaultValue(DSL.field("NULL", SQLDataType.CLOB)),
                    this,
                    "");

    public final TableField<ItemTableRecord, String> PARENT_PIVOT_ID =
            createField(
                    DSL.name("parent_pivot_id"),
                    SQLDataType.CLOB.defaultValue(DSL.field("NULL", SQLDataType.CLOB)),
                    this,
                    "");

    private ItemTable(Name alias, Table<ItemTableRecord> aliased) {
        this(alias, aliased, null);
    }

    private ItemTable(Name alias, Table<ItemTableRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table());
    }

    public ItemTable(int idTransaction) {
        this(DSL.name("ITEM_XRAY_TABLE" + idTransaction), null);
    }

    @Override
    public UniqueKey<ItemTableRecord> getPrimaryKey() {
        return Internal.createUniqueKey(
                this, DSL.name("KEY_ITEM_TABLE_XRAY_PRIMARY"), new TableField[] {this.ID}, true);
    }

    @Override
    public ItemTable as(String alias) {
        return new ItemTable(DSL.name(alias), this);
    }

    @Override
    public ItemTable as(Name alias) {
        return new ItemTable(alias, this);
    }

    @Override
    public ItemTable as(Table<?> alias) {
        return new ItemTable(alias.getQualifiedName(), this);
    }

    @Override
    public ItemTable rename(String name) {
        return new ItemTable(DSL.name(name), null);
    }

    @Override
    public ItemTable rename(Name name) {
        return new ItemTable(name, null);
    }

    @Override
    public ItemTable rename(Table<?> name) {
        return new ItemTable(name.getQualifiedName(), null);
    }

    public Field<?>[] getFields() {
        return new Field[] {
            this.ID,
            this.PROJECT,
            this.TITLE,
            this.LINK,
            this.DESCRIPTION,
            this.KEY,
            this.SUMMARY,
            this.TYPE,
            this.PRIORITY,
            this.STATUS,
            this.CREATED,
            this.REPORTER,
            this.LABEL,
            this.PIVOT_ID,
            this.PARENT_PIVOT_ID
        };
    }

    public Object[] getValues(ItemXrayDto itemXrayDto) {
        return new Object[] {
            itemXrayDto.getId(),
            itemXrayDto.getProject(),
            itemXrayDto.getTitle(),
            itemXrayDto.getLink(),
            itemXrayDto.getDescription(),
            itemXrayDto.getKey(),
            itemXrayDto.getSummary(),
            itemXrayDto.getType(),
            itemXrayDto.getPriority(),
            itemXrayDto.getStatus(),
            itemXrayDto.getCreated(),
            itemXrayDto.getReporter(),
            itemXrayDto.getLabel(),
            itemXrayDto.getPivotId(),
            itemXrayDto.getParentId()
        };
    }
}
